<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><link rel="canonical" href="https://gitlab.eclipse.org/eclipse/xfsc/xfsc-spec-2/pcme1/pcme1/" />
      <link rel="shortcut icon" href="../../img/favicon.ico" />
    <title>Personal Credential Manager Extension 1 - XFSC-spec-2</title>
    <link rel="stylesheet" href="../../css/theme.css" />
    <link rel="stylesheet" href="../../css/theme_extra.css" />
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.8.0/styles/github.min.css" />
    
      <script>
        // Current page data
        var mkdocs_page_name = "Personal Credential Manager Extension 1";
        var mkdocs_page_input_path = "pcme1\\pcme1.md";
        var mkdocs_page_url = "/eclipse/xfsc/xfsc-spec-2/pcme1/pcme1/";
      </script>
    
    <!--[if lt IE 9]>
      <script src="../../js/html5shiv.min.js"></script>
    <![endif]-->
      <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.8.0/highlight.min.js"></script>
      <script>hljs.highlightAll();</script> 
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
    <div class="wy-side-scroll">
      <div class="wy-side-nav-search">
          <a href="../.." class="icon icon-home"> XFSC-spec-2
        </a><div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../../search.html" method="get">
      <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../..">Index</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../notare/notare/">Notarization API Extension</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../train/train/">Trust Management Infrastructure</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../ocme1/ocme1/">Organization Credential Manager Extension</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../ocmwstack/ocmwstack/">Organization Credential Manager W-STACK</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../pcmcloud/pcmcloud/">Cloud Personal Credential Manager</a>
                </li>
              </ul>
              <ul class="current">
                <li class="toctree-l1 current"><a class="reference internal current" href="./">Personal Credential Manager Extension 1</a>
    <ul class="current">
    <li class="toctree-l2"><a class="reference internal" href="#1-introduction">1  Introduction</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#11-document-purpose">1.1  Document Purpose</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#12-product-scope">1.2  Product Scope</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#13-definitions-acronyms-and-abbreviations">1.3  Definitions, Acronyms and Abbreviations</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#14-references">1.4  References</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#15-document-overview">1.5  Document Overview</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#2-product-overview">2  Product Overview</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#21-product-perspective">2.1  Product Perspective</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#22-product-functions">2.2  Product Functions</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#23-product-constraints">2.3  Product Constraints</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#24-user-classes-and-characteristics">2.4  User Classes and Characteristics</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#25-operating-environment">2.5  Operating Environment</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#26-user-documentation">2.6  User Documentation</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#27-assumptions-and-dependencies">2.7  Assumptions and Dependencies</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#28-apportioning-of-requirements">2.8  Apportioning of Requirements</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#3-requirements">3  Requirements</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#31-external-interfaces">3.1  External Interfaces</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#311-user-interfaces">3.1.1  User Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#312-hardware-interfaces">3.1.2  Hardware Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#313-software-interfaces">3.1.3  Software Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#314-communications-interfaces">3.1.4  Communications Interfaces</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#32-functional">3.2  Functional</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#321-managing-connections">3.2.1  Managing Connections</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#322-managing-credentials">3.2.2  Managing Credentials</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#323-wallet-backup">3.2.3  Wallet Backup</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#324-credential-wallet-importingexporting">3.2.4  Credential Wallet Importing/Exporting</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#325-didcomm-login-support">3.2.5  DIDComm Login Support</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#326-nfc-scanning-did-input">3.2.6  NFC Scanning (DID Input)</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#327-siop-login">3.2.7  SIOP Login</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#328-app-settings-configuration-personalization">3.2.8  App Settings Configuration (personalization)</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#329-ledger-selection">3.2.9  Ledger Selection</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3210-mediator-selection">3.2.10 Mediator Selection</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3211-did-document-service-endpoint-support">3.2.11 DID Document Service Endpoint Support</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3212-cloud-wallet-management">3.2.12 Cloud wallet management</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#33-other-nonfunctional-requirements">3.3  Other Nonfunctional Requirements</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#331-http-requirements">3.3.1  HTTP Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#332-logging-requirements">3.3.2  Logging Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#333-security-requirements">3.3.3  Security Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#334-safety-requirements">3.3.4  Safety Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#335-security-requirements">3.3.5  Security Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#336-software-quality-attributes">3.3.6  Software Quality Attributes</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#337-business-rules">3.3.7  Business Rules</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#34-compliance">3.4  Compliance</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#35-design-and-implementation">3.5  Design and Implementation</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#351-installation">3.5.1  Installation</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#352-distribution">3.5.2  Distribution</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#353-usability">3.5.3  Usability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#354-maintainability">3.5.4  Maintainability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#355-portability">3.5.5  Portability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#356-interoperability">3.5.6  Interoperability</a>
    </li>
        </ul>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#4-system-features">4  System Features</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#41-managing-connections">4.1  Managing Connections</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#42-managing-credentials">4.2  Managing Credentials</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#43-wallet-backup">4.3  Wallet Backup</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#44-credential-wallet-importingexporting">4.4  Credential Wallet Importing/Exporting</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#45-didcomm-login-support">4.5  DIDComm Login support</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#46-nfc-scanning-did-input">4.6  NFC Scanning (DID Input)</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#47-siop-login">4.7  SIOP Login</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#48-app-settings-configuration-personalization">4.8  App Settings Configuration (personalization)</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#49-ledger-selection">4.9  Ledger Selection</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#410-smartphone-application">4.10 Smartphone Application</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#5-verification">5  Verification</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#51-core-verification-requirements">5.1  Core Verification Requirements</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#52-functionality-acceptance-criteria">5.2  Functionality Acceptance Criteria</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#521-connections">5.2.1  Connections</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#522-managing-credentials">5.2.2  Managing credentials</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#523-credential-wallet-synchronization">5.2.3  Credential Wallet synchronization</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#524-nfc">5.2.4  NFC</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#525-siop-login-support">5.2.5  SIOP Login Support</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#526-app-settings-configuration-personalization">5.2.6  App Settings Configuration (personalization)</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#527-ledger-selection">5.2.7  Ledger Selection</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#528-mediator-selection">5.2.8  Mediator Selection</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#529-cloud-wallet-management">5.2.9  Cloud Wallet Management</a>
    </li>
        </ul>
    </li>
        </ul>
    </li>
    </ul>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../tsae1/tsae1/">Trust Services API Extension</a>
                </li>
              </ul>
      </div>
    </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
      <nav class="wy-nav-top" role="navigation" aria-label="Mobile navigation menu">
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../..">XFSC-spec-2</a>
        
      </nav>
      <div class="wy-nav-content">
        <div class="rst-content"><div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../.." class="icon icon-home" aria-label="Docs"></a></li>
      <li class="breadcrumb-item active">Personal Credential Manager Extension 1</li>
    <li class="wy-breadcrumbs-aside">
    </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
            <div class="section" itemprop="articleBody">
              
                <h2 id="software-requirements-specification-for-gaia-x-federation-services-personal-credential-manager-extension-1-idmpcme1">Software Requirements Specification for Gaia-X Federation Services Personal Credential Manager Extension 1 IDM.PCM.E1</h2>
<p>Published by</p>
<p>eco -- Association of the Internet Industry (eco -- Verband der Internetwirtschaft e.V.) Lichtstrasse 43h 50825 Cologne, Germany</p>
<p>Copyright </p>
<p>© 2023 eco -- Association of the Internet Industry
This work is licensed under the Creative Commons attribution 4.0nInternational License. To view a copy of this license, visit <a href="http://creativecommons.org/licenses/by/4.0/">http://creativecommons.org/licenses/by/4.0/</a> or send a letter to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA</p>
<p><img alt="" src="../media/image1.png" /></p>
<h4 id="1-introduction">1  <a href="#introduction">Introduction </a></h4>
<blockquote>
<h5 id="11-document-purpose">1.1  <a href="#document-purpose">Document Purpose </a></h5>
<h5 id="12-product-scope">1.2  <a href="#product-scope">Product Scope </a></h5>
<h5 id="13-definitions-acronyms-and-abbreviations">1.3  <a href="#definitions-acronyms-and-abbreviations">Definitions, Acronyms and Abbreviations</a></h5>
<h5 id="14-references">1.4  <a href="#references">References </a></h5>
<h5 id="15-document-overview">1.5  <a href="#document-overview">Document Overview </a></h5>
</blockquote>
<h4 id="2-product-overview">2  <a href="#product-overview">Product Overview </a></h4>
<blockquote>
<h5 id="21-product-perspective">2.1  <a href="#product-perspective">Product Perspective </a></h5>
<h5 id="22-product-functions">2.2  <a href="#product-functions">Product Functions </a></h5>
<h5 id="23-product-constraints">2.3  <a href="#product-constraints">Product Constraints </a></h5>
<h5 id="24-user-classes-and-characteristics">2.4  <a href="#user-classes-and-characteristics">User Classes and Characteristics</a></h5>
<h5 id="25-operating-environment">2.5  <a href="#operating-environment">Operating Environment </a></h5>
<h5 id="26-user-documentation">2.6  <a href="#user-documentation">User Documentation </a></h5>
<h5 id="27-assumptions-and-dependencies">2.7  <a href="#assumptions-and-dependencies">Assumptions and Dependencies </a></h5>
<h5 id="28-apportioning-of-requirements">2.8  <a href="#apportioning-of-requirements">Apportioning of Requirements</a></h5>
</blockquote>
<h4 id="3-requirements">3  <a href="#requirements">Requirements </a></h4>
<blockquote>
<h5 id="31-external-interfaces">3.1  <a href="#external-interfaces">External Interfaces </a></h5>
<blockquote>
<h6 id="311-user-interfaces">3.1.1  <a href="#user-interfaces">User Interfaces </a></h6>
<h6 id="312-hardware-interfaces">3.1.2  <a href="#hardware-interfaces">Hardware Interfaces </a></h6>
<h6 id="313-software-interfaces">3.1.3  <a href="#software-interfaces">Software Interfaces </a></h6>
<h6 id="314-communications-interfaces">3.1.4  <a href="#communications-interfaces">Communications Interfaces </a></h6>
</blockquote>
<h5 id="32-functional">3.2  <a href="#functional">Functional </a></h5>
<blockquote>
<h6 id="321-managing-connections">3.2.1  <a href="#managing-connections">Managing Connections </a></h6>
<h6 id="322-managing-credentials">3.2.2  <a href="#managing-credentials">Managing Credentials </a></h6>
<h6 id="323-wallet-backup">3.2.3  <a href="#wallet-backup">Wallet Backup </a></h6>
<h6 id="324-credential-wallet-importingexporting">3.2.4  <a href="#credential-wallet-importingexporting">Credential Wallet Importing/Exporting</a></h6>
<h6 id="325-didcomm-login-support">3.2.5  <a href="#didcomm-login-support">DIDComm Login Support </a></h6>
<h6 id="326-nfc-scanning-did-input">3.2.6  <a href="#nfc-scanning-did-input">NFC Scanning (DID Input) </a></h6>
<h6 id="327-siop-login">3.2.7  <a href="#siop-login">SIOP Login </a></h6>
<h6 id="328-app-settings-configuration-personalization">3.2.8  <a href="#app-settings-configuration-personalization">App Settings Configuration (personalization)</a></h6>
<h6 id="329-ledger-selection">3.2.9  <a href="#ledger-selection">Ledger Selection </a></h6>
<h6 id="3210-mediator-selection">3.2.10 <a href="#mediator-selection">Mediator Selection </a></h6>
<h6 id="3211-did-document-service-endpoint-support">3.2.11 <a href="#did-document-service-endpoint-support">DID Document Service Endpoint Support</a></h6>
<h6 id="3212-cloud-wallet-management">3.2.12 <a href="#cloud-wallet-management">Cloud wallet management </a></h6>
</blockquote>
<h5 id="33-other-nonfunctional-requirements">3.3  <a href="#other-nonfunctional-requirements">Other Nonfunctional Requirements</a></h5>
<blockquote>
<h6 id="331-http-requirements">3.3.1  <a href="#http-requirements">HTTP Requirements </a></h6>
<h6 id="332-logging-requirements">3.3.2  <a href="#logging-requirements">Logging Requirements </a></h6>
<h6 id="333-security-requirements">3.3.3  <a href="#security-requirements">Security Requirements </a></h6>
<h6 id="334-safety-requirements">3.3.4  <a href="#safety-requirements">Safety Requirements </a></h6>
<h6 id="335-security-requirements">3.3.5  <a href="#security-requirements-1">Security Requirements </a></h6>
<h6 id="336-software-quality-attributes">3.3.6  <a href="#software-quality-attributes">Software Quality Attributes</a></h6>
<h6 id="337-business-rules">3.3.7  <a href="#business-rules">Business Rules </a></h6>
</blockquote>
<h5 id="34-compliance">3.4  <a href="#compliance">Compliance </a></h5>
<h5 id="35-design-and-implementation">3.5  <a href="#design-and-implementation">Design and Implementation </a></h5>
<blockquote>
<h6 id="351-installation">3.5.1  <a href="#installation">Installation </a></h6>
<h6 id="352-distribution">3.5.2  <a href="#distribution">Distribution </a></h6>
<h6 id="353-usability">3.5.3  <a href="#usability">Usability </a></h6>
<h6 id="354-maintainability">3.5.4  <a href="#maintainability">Maintainability </a></h6>
<h6 id="355-portability">3.5.5  <a href="#portability">Portability </a></h6>
<h6 id="356-interoperability">3.5.6  <a href="#interoperability">Interoperability </a></h6>
</blockquote>
</blockquote>
<h4 id="4-system-features">4  <a href="#system-features">System Features </a></h4>
<blockquote>
<h5 id="41-managing-connections">4.1  <a href="#managing-connections-system-features">Managing Connections </a></h5>
<h5 id="42-managing-credentials">4.2  <a href="#managing-credentials-system-features">Managing Credentials </a></h5>
<h5 id="43-wallet-backup">4.3  <a href="#wallet-backup-system-features">Wallet Backup </a></h5>
<h5 id="44-credential-wallet-importingexporting">4.4  <a href="#credential-wallet-importingexporting-system-features">Credential Wallet Importing/Exporting </a></h5>
<h5 id="45-didcomm-login-support">4.5  <a href="#didcomm-login-support-system-features">DIDComm Login support </a></h5>
<h5 id="46-nfc-scanning-did-input">4.6  <a href="#nfc-scanning-did-input-system-features">NFC Scanning (DID Input) </a></h5>
<h5 id="47-siop-login">4.7  <a href="#siop-login-system-features">SIOP Login </a></h5>
<h5 id="48-app-settings-configuration-personalization">4.8  <a href="#app-settings-configuration-personalization-system-features">App Settings Configuration (personalization)</a></h5>
<h5 id="49-ledger-selection">4.9  <a href="#ledger-selection-system-features">Ledger Selection </a></h5>
<h5 id="410-smartphone-application">4.10 <a href="#smartphone-application">Smartphone Application </a></h5>
</blockquote>
<h4 id="5-verification">5  <a href="#verification">Verification </a></h4>
<blockquote>
<h5 id="51-core-verification-requirements">5.1  <a href="#core-verification-requirements">Core Verification Requirements</a></h5>
<h5 id="52-functionality-acceptance-criteria">5.2  <a href="#functionality-acceptance-criteria">Functionality Acceptance Criteria</a></h5>
<blockquote>
<h6 id="521-connections">5.2.1  <a href="#connections">Connections </a></h6>
<h6 id="522-managing-credentials">5.2.2  <a href="#managing-credentials-verification">Managing credentials </a></h6>
<h6 id="523-credential-wallet-synchronization">5.2.3  <a href="#credential-wallet-synchronization">Credential Wallet synchronization</a></h6>
<h6 id="524-nfc">5.2.4  <a href="#nfc">NFC </a></h6>
<h6 id="525-siop-login-support">5.2.5  <a href="#siop-login-support">SIOP Login Support </a></h6>
<h6 id="526-app-settings-configuration-personalization">5.2.6  <a href="#app-settings-configuration-personalization-verification">App Settings Configuration (personalization)</a></h6>
<h6 id="527-ledger-selection">5.2.7  <a href="#ledger-selection-verification">Ledger Selection </a></h6>
<h6 id="528-mediator-selection">5.2.8  <a href="#mediator-selection-verification">Mediator Selection </a></h6>
<h6 id="529-cloud-wallet-management">5.2.9  <a href="#cloud-wallet-management-verification">Cloud Wallet Management </a></h6>
</blockquote>
</blockquote>
<p><a href="#appendix-a-glossary">Appendix A: Glossary </a></p>
<p><a href="#appendix-b-consent-management">Appendix B: Consent Management </a></p>
<p>Appendix C: Personal Credential Manager Layering overview</p>
<h2 id="list-of-figures">List of Figures</h2>
<blockquote>
<p>Figure 1: Personal Credentials Manager. Layering overview (s. appendix C) </p>
<p>Figure 2: Personal Credentials Manager: Component View
</p>
</blockquote>
<h2 id="list-of-tables">List of Tables</h2>
<blockquote>
<p>Table 1: References </p>
<p>Table 2: User Classes and Characteristics </p>
<p>Table 3: Apportioning of Requirements </p>
<p>Table 4: Functional Requirements Connection Management</p>
<p>Table 5: Functional Requirements Credential Management</p>
<p>Table 6: Functional Requirements Wallet Backup </p>
<p>Table 7: Functional Requirements Credential Wallet Importing/Exporting </p>
<p>Table 8: Functional Requirements DIDComm Login support</p>
<p>Table 9: Functional Requirements NFC Scanning (DID Input)</p>
<p>Table 10: Functional Requirements SIOP Login </p>
<p>Table 11: Functional Requirements App Settings Configuration (personalization) </p>
<p>Table 12: Functional Requirements Ledger Selection </p>
</blockquote>
<h1 id="introduction">Introduction</h1>
<blockquote>
<p>To get general information regarding Gaia-X and the Gaia-X Federation Services please refer to [TAD] and [PRD].</p>
</blockquote>
<h2 id="document-purpose">Document Purpose</h2>
<blockquote>
<p>The purpose of the document is to specify the requirements of the Identity Management and Trust Subcomponent "Personal Credential Manager" with the intention of a European wide public tender for implementing this software. Main audience for this document is attendees of the public tender, which are able to supply an open-source software solution for the area of identity and document verification with the purpose to provide a credential manager application to be used by natural persons to participate in the Gaia-X trust structure.</p>
</blockquote>
<h2 id="product-scope">Product Scope</h2>
<blockquote>
<p>The purpose of this product is to provide all necessary components for the self-sovereign administration of the digital identity of a principal in the Gaia-X context on a mobile device. The Personal Credential Manager enables a natural person to act as a <em>principal</em> of an organization within the SSI-based Gaia-X ecosystem in a privacy-preserving, trustful and secure way. This comprises the following main functionalities:</p>
</blockquote>
<ul>
<li>
<p>AIP 2.0 Support</p>
</li>
<li>
<p>Reception and management of W3C verifiable credentials</p>
</li>
<li>
<p>Presenting W3C and AIP 2.0 Verifiable Presentations to other parties in a proved manner</p>
</li>
<li>
<p>Secure storage and management of respective secrets</p>
</li>
<li>
<p>Remote Management of the PCM Cloud Solution</p>
</li>
<li>
<p>Support of the Cloud PCM functionality</p>
</li>
<li>
<p>Enhancements in QR Code Support Reading and Presentation</p>
</li>
</ul>
<blockquote>
<p>Extension of the Personal Credential Manager must be developed as additional features of the existing smartphone-based application for Android and iPhone platforms.</p>
<p>Furthermore, the scope includes the provision of the developed software in a usable format for end users including the respective distribution channels (e.g., App Stores).</p>
</blockquote>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /></p>
<p>If it's required to do code restructurings, modifying the current solution by adding new microservices etc. then this is explicitly allowed.</p>
<p>Please note, that it is explicitly required to deliver the software up and running. Responsibility for existing code cannot be shifted to previous development teams.</p>
</blockquote>
<hr />
<h2 id="definitions-acronyms-and-abbreviations">Definitions, Acronyms and Abbreviations</h2>
<blockquote>
<p>All requirements from other documents are referenced by [IDM.\&lt;document-id&gt;.XXXXX] as defined in the chapter "Methodology" in the document [IDM.AO].</p>
</blockquote>
<h2 id="references">References</h2>
<table>
<thead>
<tr>
<th>Concept</th>
<th>Source</th>
<th>Status</th>
</tr>
</thead>
<tbody>
<tr>
<td>Hyperledger Aries Concepts (AIP2.0)</td>
<td><a href="https://github.com/hyperledger/aries-rfcs/tree/main/concepts/0302-aries-interop-profile">GitHub</a></td>
<td>03-17-2023</td>
</tr>
<tr>
<td>Specflow (Getting Started with BDD)</td>
<td><a href="https://specflow.org/bdd/">Specflow</a></td>
<td>03-18-2023</td>
</tr>
<tr>
<td>Cryptographic Key Length Recommendation (CryptoLen)</td>
<td><a href="https://www.keylength.com/en">KeyLength</a></td>
<td>03-18-2023</td>
</tr>
<tr>
<td>DIDComm Messaging (Daniel Hardman)</td>
<td><a href="https://identity.foundation/didcomm-messaging/spec/#out-of-band-messages">Identity Foundation</a></td>
<td>03-18-2023</td>
</tr>
<tr>
<td>OpenID Self-Issued OpenID Connect Provider DID</td>
<td><a href="https://openid.net/specs/openid-connect-self-issued-v2-1_0.html">OpenID</a></td>
<td>-</td>
</tr>
<tr>
<td>FIPS 140-2 (Federal Information Processing Standard)</td>
<td><a href="https://en.wikipedia.org/wiki/FIPS_140-2">Wikipedia</a></td>
<td>03-17-2023</td>
</tr>
<tr>
<td>Gaia-X WP1 (Architecture Overview)</td>
<td>Refer to "annex_IDM.AO" (Base of functional specification)</td>
<td>-</td>
</tr>
<tr>
<td>GXFS Organization Credential Manager W-Stack</td>
<td>Refer to "annex_IDM.OCM.W-STACK"</td>
<td>-</td>
</tr>
<tr>
<td>Gaia-X Federation Service Non-functional Requirements (NF.SPBD)</td>
<td>Refer to annex "GXFS_Nonfunctional_Requirements_SPBD"</td>
<td>-</td>
</tr>
<tr>
<td>OpenID for Verifiable Credential Issuance (OID4VC)</td>
<td><a href="https://openid.net/specs/openid-4-verifiable-credential-issuance-1_0.html">OpenID</a></td>
<td>03-17-2023</td>
</tr>
<tr>
<td>OpenID for Verifiable Presentations (OID4VP)</td>
<td><a href="https://openid.net/specs/openid-4-verifiable-presentations-1_0.html">OpenID</a></td>
<td>03-17-2023</td>
</tr>
<tr>
<td>Gaia-X Policy Rules (PRD)</td>
<td><a href="https://docs.gaia-x.eu/policy-rules-committee/policy-rules-labelling/22.11/">Gaia-X Docs</a></td>
<td>-</td>
</tr>
<tr>
<td>SOG-IS Crypto Evaluation Scheme (SOG-IS)</td>
<td><a href="https://www.sogis.eu/documents/cc/crypto/SOGIS-Agreed-Cryptographic-Mechanisms-1.2.pdf">SOG-IS Document</a></td>
<td>03-18-2023</td>
</tr>
<tr>
<td>Gaia-X Architecture Document (TAD)</td>
<td><a href="https://docs.gaia-x.eu/technical-committee/architecture-document/22.10/#new_tab">Gaia-X Docs</a></td>
<td>03-17-2023</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 1: References</p>
</blockquote>
<h2 id="document-overview">Document Overview</h2>
<blockquote>
<p>The document describes the product perspective, functions, and constraints. It furthermore lists the functional and non-functional requirements and defines the additional system features in detail. The listed requirements are binding. Requirements as an expression of normative specifications are identified by a unique ID in square brackets (e.g. <strong>[IDM.ID.EX.Number]</strong>) and the keywords MUST, MUST NOT, SHOULD, SHOULD NOT, MAY, corresponding to RFC 2119 [RFC 2119], are written in capital letters (see also [IDM.AO] - Methodology).</p>
</blockquote>
<h1 id="product-overview">Product Overview</h1>
<h2 id="product-perspective">Product Perspective</h2>
<blockquote>
<p>The personal credential manager is used by a natural person. Within the Gaia-X terminology, such a natural person is named <em>principal</em>. The principal utilizes the PCM in the respective form factor to store VCs issued to her/him as well as to prove the statements necessary to obtain a service.</p>
<p>The PCM must extend the support of following overall processes:</p>
</blockquote>
<ul>
<li>
<p>DIDComm Authentication as the generic way to authenticate a principal</p>
</li>
<li>
<p>Secure backup and restore by file</p>
</li>
<li>
<p>SIOP DID as a method to implement SSI based Login Methods [DID SIOP]</p>
</li>
<li>
<p>Consent Management</p>
</li>
<li>
<p>OIDC4VP for presenting Credentials</p>
</li>
<li>
<p>OIDC4VC to receive Credentials</p>
</li>
<li>
<p>Remote Management and Usage of cPCM</p>
</li>
<li>
<p>DID Document Based Protocol Selection</p>
</li>
<li>
<p>AIP 1.0 Protocol</p>
</li>
<li>
<p>AIP 2.0 Protocol [AIP2.0]</p>
</li>
<li>
<p>Bi-directional synchronization with Cloud Personal Credential Wallet</p>
</li>
<li>
<p>Train Selection</p>
</li>
</ul>
<hr />
<p><img alt="" src="../media/image2.png" /></p>
<h2 id="the-existing-code-base-must-be-reused-and-further-improved-other-microservices-may-have-different-languages-and-architectures">&gt; The existing code base MUST be reused and further improved. Other microservices MAY have different languages and architectures.</h2>
<h2 id="product-functions">Product Functions</h2>
<blockquote>
<p>Personal Credentials Manager (PCM) enables end-users to interact with the DID-based ecosystem in a privacy-preserving way. PCM acts as a user representative tool which is securely holding the acquired distributed identities and identity attributes and provides the technical means to selectively disclose the aforementioned attributes for authentication and service consumption. The following represents the high-level functional architecture of the PCM.</p>
</blockquote>
<p><img alt="" src="../media/image3.png" /></p>
<blockquote>
<p>Figure 1: Personal Credentials Manager. Layering overview (s. appendix C)</p>
<p>As presented in the PCM big picture layering overview, PCM consists of different components which effectively comprise the following layers:</p>
</blockquote>
<ul>
<li>
<p>The front-end layer</p>
</li>
<li>
<p>PCM Core (Wallet) layer</p>
</li>
<li>
<p>as well as the Mediator (Relay) layer</p>
</li>
</ul>
<blockquote>
<p><strong>The front-end layer</strong> is comprised of the following features and components:</p>
</blockquote>
<ul>
<li>
<p>End User Authentication</p>
</li>
<li>
<p>Graphical User Interface (GUI)</p>
</li>
<li>
<p>Local Input Interfaces</p>
</li>
</ul>
<blockquote>
<p><em>End User Authentication</em> component provides for the implementation of secure user authentication policies which can include but are not limited to fingerprint authentication in the smart phone case, PIN, password, etc.</p>
<p><em>The GUI component</em> enables end users to interact with the PCM and use the PCM functions. <em>Local Input Interfaces</em> comprise QR-code processing, bootstrapping over Near Field Communication (NFC), etc., and by that provides communication initiation, direct, or peer-to-peer (contact) exchange as well as credentials presentation ensuring the
direct proximity requirements.</p>
<p><strong>PCM Core (Wallet) layer</strong> consists of the following features and components:</p>
</blockquote>
<ul>
<li>
<p>W3C VC synchronization with cPCM for offline Presentation</p>
</li>
<li>
<p>Consent Management over cPCM</p>
</li>
<li>
<p>Remote Management of cPCM</p>
</li>
<li>
<p>Backup/Restore over cPCM</p>
</li>
<li>
<p>Remote Control of the Cloud PCM by using a didcomm protocol over the websocket connection</p>
</li>
</ul>
<blockquote>
<p>The <em>Managing Credentials</em> feature provides the functionality for receiving credentials issued by other participants, enabling the user to view and inspect his/her credentials, and the basic functionality for proofing credential attributes to other participants according to the SSI paradigm. The credential manager ensures that the user is always in control, which attributes are provided to which participant. It further enables to create and check proofs according to the SSI paradigm to, for example, achieve DIDComm or SIOP Login, etc.</p>
<p>The <em>Wallet Backup</em> feature provides for the secure backup and restore capabilities of the obtained credentials and possibly the app settings.</p>
<p>The automatic synchronization feature enables the users to configure a unique channel of communication between PCM and cPCM. Which enables the und users to synchronize W3C VC from PCM to cPCM and via versa.</p>
<p>The figure below is the planned component structure which are a matter of this tender (derivations allowed from SW perspective):</p>
<p><img alt="" src="../media/image4.png" />
</p>
</blockquote>
<h2 id="figure-2-personal-credentials-manager-component-view">&gt;Figure 2: Personal Credentials Manager: Component View</h2>
<blockquote>
<p><img alt="" src="../media/image2.png" /></p>
<p>The existing code base contains partially the components on this picture. In a planned software architecture for this tender all of these components MUST be considered for restructuring the code.</p>
</blockquote>
<hr />
<h2 id="product-constraints">Product Constraints</h2>
<h5 id="idmpcme100000-oid4vpvc-compatibility">[IDM.PCM.E1.00000] OID4VP/VC Compatibility</h5>
<blockquote>
<p>The PCM MUST support exchange over OID4VP protocol [OID4VP] and all other applicable standards needed for communication with the Organization Credential Manager and OCM W- Stack [IDM.OCM.W-STACK].
</p>
</blockquote>
<h5 id="idmpcme100001-aip-20-compatibility">[IDM.PCM.E1.00001] AIP 2.0 Compatibility</h5>
<blockquote>
<p>The PCM MUST support AIP 2.0 as specified in Aries Interop Profile [AIP2.0].  </p>
</blockquote>
<h5 id="idmpcme100002-offline-presentation">[IDM.PCM.E1.00002] Offline Presentation</h5>
<blockquote>
<p>All W3C credentials in the wallet (including the synced one) MUST be available for the offline presentation. "Offline" is in this case defined as "No third Party involved" which is able to track the data. Means the presentation MUST be possible by QR Code, NFC or Bluetooth peer to peer from one Smartphone to the other. This includes a capability to identify trusted verifiers and issuers on the smartphone before presentation e.g., by using Bloom Filters.  </p>
</blockquote>
<h5 id="idmpcme100003-cloud-pcm">[IDM.PCM.E1.00003] Cloud PCM</h5>
<blockquote>
<p>The Cloud PCM (also part oft his tender) MUST be used as Integration Layer and as remote backend to store and synchronize W3C credentials including the remote management/control of the cPCM agents and backup storage. The cPCM connection MUST NOT implement Aries</p>
<p>Protocols or Aries RFCs, because the PCM and cPCM connection acts as private connection of the PCM Smartphone App with its private backend (cPCM).  </p>
</blockquote>
<h2 id="user-classes-and-characteristics">User Classes and Characteristics</h2>
<table>
<thead>
<tr>
<th>User Class</th>
<th>Description</th>
<th>Expertise</th>
<th>Privilege Level</th>
<th>Product Usage</th>
</tr>
</thead>
<tbody>
<tr>
<td>Personal User</td>
<td>The person in possession of the personal credential manager using all functionality of the product</td>
<td>Low</td>
<td>High</td>
<td>Frontend</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 2: User Classes and Characteristics</p>
</blockquote>
<h2 id="operating-environment">Operating Environment</h2>
<blockquote>
<p>Please refer to [TDR] for further binding requirements regarding the operating environment.</p>
</blockquote>
<h5 id="idmpcme100003-operating-environments">[IDM.PCM.E1.00003] Operating Environments</h5>
<blockquote>
<p>The product needs to support different operating environments.</p>
</blockquote>
<ul>
<li>
<p>Android operating system versions which are still supported by Google (as of now &gt; Android version 9) MUST be supported.</p>
</li>
<li>
<p>iOS operating system versions which are still supported by Apple MUST be supported.</p>
</li>
</ul>
<blockquote></blockquote>
<h2 id="user-documentation">User Documentation</h2>
<blockquote>
<p>Please refer to [TDR] for further requirements regarding documentation.</p>
</blockquote>
<h5 id="idmpcme100004-participant-administration-documentation">[IDM.PCM.E1.00004] Participant Administration Documentation</h5>
<blockquote>
<p>The documentation MUST contain:</p>
</blockquote>
<ul>
<li>
<p>Installation Manuals</p>
</li>
<li>
<p>Cryptographic Initialization (if applicable)</p>
</li>
<li>
<p>Description of Deployment/Compile Process</p>
</li>
<li>
<p>Description of the Automatic Tests / Verification</p>
</li>
<li>
<p>How to build the product from source code  </p>
</li>
</ul>
<h5 id="idmpcme100005-participant-documentation">[IDM.PCM.E1.00005] Participant Documentation</h5>
<blockquote>
<p>The documentation MUST contain:</p>
</blockquote>
<ul>
<li>
<p>Short Software Description/Usage</p>
</li>
<li>
<p>Usage Guide</p>
</li>
<li>
<p>GDPR Design Decisions</p>
</li>
<li>
<p>Security Concept</p>
</li>
<li>
<p>Operations Concept</p>
</li>
<li>
<p>FAQ</p>
</li>
<li>
<p>Keyword Directory  </p>
</li>
</ul>
<h2 id="assumptions-and-dependencies">Assumptions and Dependencies</h2>
<blockquote>
<p>An understanding of the overall Gaia-X architecture and philosophy is necessary. Please refer to [TAD] and [PRD].</p>
</blockquote>
<h2 id="apportioning-of-requirements">Apportioning of Requirements</h2>
<table>
<thead>
<tr>
<th>Feature</th>
<th>Priority</th>
</tr>
</thead>
<tbody>
<tr>
<td>OIDV4VP/VC support</td>
<td>1</td>
</tr>
<tr>
<td>AIP 2.0 support</td>
<td>1</td>
</tr>
<tr>
<td>Cloud wallet synchronization</td>
<td>1</td>
</tr>
<tr>
<td>QR generation</td>
<td>1</td>
</tr>
<tr>
<td>NFC tag generation</td>
<td>1</td>
</tr>
<tr>
<td>NFC Scanning (DID Input)</td>
<td>1</td>
</tr>
<tr>
<td>SIOP Login</td>
<td>1</td>
</tr>
<tr>
<td>cPCM Remote Control</td>
<td>1</td>
</tr>
<tr>
<td>Consent Management</td>
<td>1</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 3: Apportioning of Requirements</p>
</blockquote>
<h1 id="requirements">Requirements</h1>
<blockquote>
<p>Further binding requirements can be found in [TDR].</p>
</blockquote>
<h2 id="external-interfaces">External Interfaces</h2>
<h3 id="user-interfaces">User Interfaces</h3>
<h5 id="idmpcme100006-smartphone-gui">[IDM.PCM.E1.00006] Smartphone GUI</h5>
<blockquote>
<p>The PCM MUST provide a GUI for the PCM user to support the enhancements for the Cloud PCM. This requires support for Consent Management, as well for Notifications and the support of W3C credentials provided by the OCM W-Stack [IDM.OCM.W-STACK].  </p>
</blockquote>
<h3 id="hardware-interfaces">Hardware Interfaces</h3>
<h5 id="idmpcme100007-camera">[IDM.PCM.E1.00007] Camera</h5>
<blockquote>
<p>The PCM MUST be able to use the Smartphone's camera to scan QR-Codes for W3C credentials and OpenID4VC issuing Proposals [OID4VC].  </p>
</blockquote>
<h5 id="idmpcme100008-nfc">[IDM.PCM.E1.00008] NFC</h5>
<blockquote>
<p>The PCM must be able to use the Smartphone's NFC communication to receive DIDComm invitation messages, OpenID4VC Issuing Proposals and W3C Credentials.  </p>
</blockquote>
<h3 id="software-interfaces">Software Interfaces</h3>
<h5 id="idmpcme100009-secure-storage">[IDM.PCM.E1.00009] Secure Storage</h5>
<blockquote>
<p>The PCM implementation MUST be able to use secure storage (internal storage, encrypted storage, dedicated key storage) by using enclaves provided by the target platform/smartphone operating system for storing PCM data within the smartphone. Especially for key exchange between the Cloud PCM and the PCM App is this required to protect the keys safely. It's highly recommended to use asymmetric encryption protocols by utilizing internal enclaves to exchange the keys (e.g., CMS or other schemes)  </p>
</blockquote>
<h3 id="communications-interfaces">Communications Interfaces</h3>
<h5 id="idmpcme100010-didcomm-v2-interface">[IDM.PCM.E1.00010] DIDComm v2 Interface</h5>
<blockquote>
<p>The DIDComm interface MUST be provided to send DIDComm messages to be processed by the PCM and the PCM Cloud.  </p>
</blockquote>
<h5 id="idmpcme100011-nfc">[IDM.PCM.E1.00011] NFC</h5>
<blockquote>
<p>The PCM App MUST support the exchange of W3C VCs/VPs and Connection invitations by using NFC (reading and presentation).  </p>
</blockquote>
<h5 id="idmpcme100011-local-siop-endpoint">[IDM.PCM.E1.00011] Local SIOP Endpoint</h5>
<blockquote>
<p>The PCM MUST provide an endpoint for SIOP requests [DID SIOP]. Within the SIOP protocol, the PCM implements the role of the Self-Issued OpenID Provider (SIOP). Applications (PRs (Relying Parties) in SIOP terminology can send SIOP requests to the PCM. The PCM will process such requests and reply with a SIOP response. The SIOP process MUST be triggerable via an URL scheme which is registered during the App Installation (e.g., gxfspcm://siop?...)  </p>
</blockquote>
<h5 id="idmpcme100012-personal-wallet-and-secrets-synchronization">[IDM.PCM.E1.00012] Personal Wallet and Secrets Synchronization</h5>
<blockquote>
<p>Given that PCM users for security reasons import or export their Personal Wallet and secrets, an interface MUST be provided so that Synchronization between PCM and Cloud Wallet (cPCM) can be established by using web socket protocols. This feature is dedicated to W3Cs and is not relevant for Aries based credentials. All secrets relevant for presentation of W3C credentials MUST be transferred encrypted and in an approach that the private key isn't transmitted at once and just "activatable" by user knowledge. For instance, by using key derivation functions.  </p>
</blockquote>
<h5 id="idmpcme100013-mediator-selection-based-on-did-document">[IDM.PCM.E1.00013] Mediator selection based on DID document</h5>
<blockquote>
<p>PCM needs to be able to find the correct mediator, based on the record in the DID document as well the other endpoints for communication MUST be discovered by the DID document. All endpoint types MUST be configurable with the following format by enhancing the W3C spec [1]:</p>
<pre><code>                &gt; {

                &gt; id: {idName}

                &gt; type: {typeName},

                &gt; accept: \["didcomm/v2","didcomm/v1",{otherProtocols}\],

                &gt; serviceEndpoint:\["https://..."\]

                &gt; }
</code></pre>
</blockquote>
<h6 id="1-httpswwww3orgtrdid-coreexample-usage-of-the-service-property">[1] <a href="https://www.w3.org/TR/did-core/#example-usage-of-the-service-property"><u>[https://www.w3.org/TR/did-core/#example-usage-of-the-service-property]</u></a></h6>
<h5 id="idmpcme100014-cpcm-connection">[IDM.PCM.E1.00014] cPCM Connection</h5>
<blockquote>
<p>The mobile application needs a secure communication web socket channel to the PCM Cloud to synchronize Credentials, receiving Consent Notifications, Credential Requests etc. The application MUST implement for this purpose WebSockets and didcomm v2. The message protocol provided by the cPCM MUST be implemented and documented as "RFC" similar to Hyperledger Aries RFC documentation format [2].  </p>
</blockquote>
<h6 id="2-httpsgithubcomhyperledgeraries-rfcsblobmainconcepts0074-didcomm-best-practicesreadmemdrfc-naming">[2] <a href="https://github.com/hyperledger/aries-rfcs/blob/main/concepts/0074-didcomm-best-practices/README.md#rfc-naming"><u>[https://github.com/hyperledger/aries-rfcs/blob/main/concepts/0074-didcomm-best-practices/README.md#rfc-naming]</u></a></h6>
<h2 id="functional">Functional</h2>
<h3 id="managing-connections">Managing Connections</h3>
<h5 id="idmpcme100015-connection-creation-via-invitation">[IDM.PCM.E1.00015] Connection creation via invitation</h5>
<blockquote>
<p>DIDComm connection requests can be provided to the PCM user via QR-Code, Text input (URL), NFC (Out of band messages according to DIDComm Messaging specification [DIDComm]), and by regular DIDComm messages received. Especially for the device pairing between PCM and Cloud OCM MUST be process described and developed (e.g., by a special invitation protocol)  </p>
</blockquote>
<h3 id="managing-credentials">Managing Credentials</h3>
<h5 id="idmpcme100016-receive-a-verifiable-credential-vc">[IDM.PCM.E1.00016] Receive a Verifiable Credential (VC)</h5>
<blockquote>
<p>The PCM MUST be able to receive VCs according to AIP 2.0 and OpenId4VC Standards for the underlying issuing protocols. The AIP 1.0 functionality MUST remain and still be supported in the App.  </p>
</blockquote>
<h5 id="idmpcme100017-answer-request-for-verifiable-presentation-vp">[IDM.PCM.E1.00017] Answer Request for Verifiable Presentation (VP)</h5>
<blockquote>
<p>The PCM MUST be able to answer presentation requests according to AIP 2.0 and OpenId4VC Standards for the underlying issuing protocols. The AIP 1.0 functionality MUST remain and still be supported in the App.  </p>
</blockquote>
<h5 id="idmpcme100018-display-history-of-presenting-verifiable-presentations-vps-to-other-participants">[IDM.PCM.E1.00018] Display history of presenting verifiable Presentations (VPs) to other participants</h5>
<blockquote>
<p>The PCM user can view detailed information about the history of showing/proofing identity information to other participants. For each run of the Proof protocol, the information shown MUST include all information contained in the VP shown to a verifier including the remote one from the cPCM, to which verifier it has been shown, and transaction date/time.  </p>
</blockquote>
<h3 id="wallet-backup">Wallet Backup</h3>
<h5 id="idmpcme100019-restore-backup">[IDM.PCM.E1.00019] Restore Backup</h5>
<blockquote>
<p>The PCM MUST provide a function to restore a backup containing all information stored in the PCM.</p>
<p>The Backup/Restore format MUST be compatible to guarantee PCM App interoperability between form factors and between different providers or Smartphone Applications and Cloud Wallet (cPCM). This MUST be for W3C credentials an encrypted JSON-LD file or for Aries Credentials just a file.  </p>
</blockquote>
<h3 id="credential-wallet-importingexporting">Credential Wallet Importing/Exporting</h3>
<h5 id="idmpcme100020-sync-wallets">[IDM.PCM.E1.00020] Sync Wallets</h5>
<blockquote>
<p>The PCM MUST provide a functionality to synchronize different personal cloud wallet instances (Cloud PCM), e.g., synchronize a cloud wallet (cPCM) with a smartphone wallet. Secure methods for Importing the PCM Secrets MUST be provided. The synchronization MUST consist of W3C Credentials, Aries credentials are out of scope for syncing.  </p>
</blockquote>
<h3 id="didcomm-login-support">DIDComm Login Support</h3>
<h5 id="idmpcme100021-didcomm-login-support">[IDM.PCM.E1.00021] DIDComm Login Support</h5>
<blockquote>
<p>The PCM MUST support the Login via DIDComm by using the DIDComm Login protocol of the cPCM (no aries protocol, internal protocol of cPCM).  </p>
</blockquote>
<h3 id="nfc-scanning-did-input">NFC Scanning (DID Input)</h3>
<h5 id="idmpcme100024-nfc">[IDM.PCM.E1.00024] NFC</h5>
<blockquote>
<p>The PCM MUST support scanning of W3C Credentials and Invitations via NFC. The Presentation of Credentials and Presentations MUST be provided via NFC as well. </p>
</blockquote>
<h3 id="siop-login">SIOP Login</h3>
<h5 id="idmpcme100022-siop-login-support">[IDM.PCM.E1.00022] SIOP Login Support</h5>
<blockquote>
<p>The PCM MUST implement a function to process SIOP requests [DID SIOP] in the role of the Self- Issued OpenID Provider (SIOP). Applications (RPs (Relying Parties) in SIOP terminology) can send SIOP requests to the PCM. The PCM will process such requests and reply with a SIOP response.</p>
</blockquote>
<h3 id="app-settings-configuration-personalization">App Settings Configuration (personalization)</h3>
<h5 id="idmpcme100023-configure-cloud-wallet-linking">[IDM.PCM.E1.00023] Configure Cloud wallet linking</h5>
<blockquote>
<p>The PCM MUST enable the user to configure a secure connection for data synchronization by realizing a prior pairing to the Cloud PCM via DIDComm.  </p>
</blockquote>
<h3 id="ledger-selection">Ledger Selection</h3>
<h5 id="idmpcme100024-select-ledger">[IDM.PCM.E1.00024] Select Ledger</h5>
<blockquote>
<p>The PCM MUST NOT be enabled to select compatible Ledgers. The selection is pre-configured from a list of supported ledgers and all other Information MUST be extracted from DID Documents.  </p>
</blockquote>
<h3 id="mediator-selection">Mediator Selection</h3>
<h5 id="idmpcme100025-select-mediator">[IDM.PCM.E1.00025] Select Mediator</h5>
<blockquote>
<p>The mediator MUST be selected by using the DID Document (resolved over DID) to find the right endpoints.  </p>
</blockquote>
<h3 id="did-document-service-endpoint-support">DID Document Service Endpoint Support</h3>
<h5 id="idmpcme100026-service-endpoint-usage">[IDM.PCM.E1.00026] Service Endpoint Usage</h5>
<blockquote>
<p>The DID Document Service Endpoints MUST be used for the PCM functionality, and the formats and accept attributes MUST be considered next to the key material provided by the document.</p>
</blockquote>
<h3 id="cloud-wallet-management">Cloud wallet management</h3>
<h5 id="idmpcme100027-remote-controller-of-the-cloud-pcm">[IDM.PCM.E1.00027] Remote controller of the Cloud PCM</h5>
<blockquote>
<p>The PCM user MUST be able to control the basic functions of the Cloud PCM (cPCM) such as Consent management and Credential management. The proofs requested by an external actor, can be consented by the user by using the PCM.</p>
<p>A Diagram for the Consent Management is in Appendix B and MUST be realized on SSI based W3C mechanisms.  </p>
</blockquote>
<h5 id="idmpcme100028-selective-disclosure-jwt">[IDM.PCM.E1.00028] Selective Disclosure JWT</h5>
<blockquote>
<p>The component MUST support Selective Disclosure JWT described in the specification [3]. </p>
</blockquote>
<h6 id="3-httpsdatatrackerietforgdocdraft-ietf-oauth-selective-disclosure-jwt">[3] <a href="https://datatracker.ietf.org/doc/draft-ietf-oauth-selective-disclosure-jwt/"><u>[https://datatracker.ietf.org/doc/draft-ietf-oauth-selective-disclosure-jwt/]</u></a></h6>
<h2 id="other-nonfunctional-requirements">Other Nonfunctional Requirements</h2>
<h5 id="idmpcme100029-architecture-changes">[IDM.PCM.E1.00029] Architecture Changes</h5>
<blockquote>
<p>All Architecture Changes MUST be aligned with the Principal before implementation.  </p>
</blockquote>
<h3 id="http-requirements">HTTP Requirements</h3>
<h5 id="idmpcme100030-https">[IDM.PCM.E1.00030] HTTPS</h5>
<blockquote>
<p>All HTTP communication MUST be protected by state-of-the-art transport security algorithms such as TLS 1.2 / TLS 1.3 (all protocol version numbers may be superseded by upcoming standards). Each endpoint of the product MUST support TLS certificates which are configurable by the administrator of the system.  </p>
</blockquote>
<h5 id="idmpcme100031-http-protocol-definitions">[IDM.PCM.E1.00031] HTTP Protocol Definitions</h5>
<blockquote>
<p>All HTTP Endpoints MUST follow RFC 7231 [4] and RFC 5789 [5], but it MAY be chosen what of the protocols is necessary to realize the functionality. For problem reports the RFC7807 [6] MUST be used in combination with Standard HTTP Error Codes.</p>
</blockquote>
<h6 id="4-httpstoolsietforghtmlrfc7231">[4] <a href="https://tools.ietf.org/html/rfc7231"><u>[https://tools.ietf.org/html/rfc7231]</u></a></h6>
<h6 id="5-httpstoolsietforghtmlrfc5789">[5] <a href="https://tools.ietf.org/html/rfc5789"><u>[https://tools.ietf.org/html/rfc5789]</u></a></h6>
<h6 id="6-httpstoolsietforghtmlrfc7807">[6] <a href="https://tools.ietf.org/html/rfc7807"><u>[https://tools.ietf.org/html/rfc7807]</u></a></h6>
<h3 id="logging-requirements">Logging Requirements</h3>
<h5 id="idmpcme100032-data-minimization">[IDM.PCM.E1.00032] Data Minimization</h5>
<blockquote>
<p>The data minimization principle is expressed in Article 5(1)(c) of the GDPR and Article 4(1)(c) of Regulation (EU) 2018/1725, which provide that personal data must be \"adequate, relevant and limited to what is necessary in relation to the purposes for which they are processed\". The data shall be stored for a period of time in accordance with national requirements and, as a minimum, shall consist of the following elements:</p>
</blockquote>
<p>(a) node\'s identification</p>
<p>(b) message identification</p>
<p>(c) message data and time</p>
<blockquote>
<p>All logged data/information MUST be documented in the GDPR design decisions for a GDPR review.  </p>
</blockquote>
<h3 id="security-requirements">Security Requirements</h3>
<h4 id="general-security-requirements">General Security Requirements</h4>
<blockquote>
<p>Each Gaia-X Federation Service SHALL meet the requirements stated in the document "Specification of non-functional Requirements Security and Privacy by Design" [NF.SPBD].</p>
<p>Federation Services specific requirements will be documented in the next chapter.</p>
</blockquote>
<h4 id="service-specific-security-requirements">Service Specific Security Requirements</h4>
<blockquote>
<p>This chapter will describe the service specific requirements, which will extend the requirements defined in the chapter above.</p>
</blockquote>
<h5 id="idmpcme100033-secure-user-authentication">[IDM.PCM.E1.00033] Secure user authentication</h5>
<blockquote>
<p>To ensure that only allowed entities can access the PCM authentication methods MUST be implemented to grant access to the PCM. The PCM MUST provide a method for securing user login with at least two authentication factors.  </p>
</blockquote>
<h5 id="idmpcme100034-multimodal-biometric-authentication">[IDM.PCM.E1.00034] Multimodal biometric authentication</h5>
<blockquote>
<p>The PCM MAY provide (multimodal) biometric authentication methods to improve the usability of the PCM.  </p>
</blockquote>
<h5 id="idmpcme100035-protection-of-secrets-wallet-and-security-for-the-restore-process">[IDM.PCM.E1.00035] Protection of Secrets (Wallet) and Security for the Restore process</h5>
<blockquote>
<p>The PCM secrets MUST be stored and processed securely. There MUST be additional security procedures in place to guarantee that the secret key can be recovered when the holder requires it, even in case the holder himself has lost access to his unlock key. State of the art methods that MAY be applied are for example Shamir's Secret Sharing.  </p>
</blockquote>
<h5 id="idmpcme100036-secure-communication-between-frontend-and-cloud-agentwallet">[IDM.PCM.E1.00036] Secure communication between frontend and cloud agent/wallet</h5>
<blockquote>
<p>The communication interface in case of the cloud agent/Wallet form factor must be protected according to the latest security standards.  </p>
</blockquote>
<h5 id="idmpcme100037-cryptographic-algorithms-and-cipher-suites">[IDM.PCM.E1.00037] Cryptographic Algorithms and Cipher Suites</h5>
<blockquote>
<p>Cryptographic algorithms and TLS cipher suites SHALL be chosen based on the recommendation from the German Federal Office for Information Security (BSI) or SOG-IS. These recommendations and the recommendations of other institutions and standardization organization are quite similar [7] [CryptoLen]. The recommendations can be found in the technical guidelines [8] TR 02102- 1 [TR02102-1] and TR 02102-2 [TR02102-2] or SOG-IS Agreed Cryptographic Mechanisms [9] [SOG- IS].  </p>
</blockquote>
<h6 id="7-see-httpswwwkeylengthcomen-for-a-comparison">[7] See <a href="https://www.keylength.com/en"><u>[https://www.keylength.com/en]</u></a> for a comparison</h6>
<h6 id="8-see-httpswwwbsibunddeenservice-navipublicationstechnicalguidelinestr02102tr02102_nodehtml-for-a-comparison">[8] See <a href="https://www.bsi.bund.de/EN/Service-Navi/Publications/TechnicalGuidelines/tr02102/tr02102_node.html"><u>[https://www.bsi.bund.de/EN/Service-Navi/Publications/TechnicalGuidelines/tr02102/tr02102_node.html]</u></a> for a comparison</h6>
<h6 id="9-see-httpswwwsogiseudocumentscccryptosogis-agreed-cryptographic-mechanisms-12pdf-for-a-comparison">[9] See <a href="https://www.sogis.eu/documents/cc/crypto/SOGIS-Agreed-Cryptographic-Mechanisms-1.2.pdf"><u>[https://www.sogis.eu/documents/cc/crypto/SOGIS-Agreed-Cryptographic-Mechanisms-1.2.pdf]</u></a> for a comparison</h6>
<h5 id="idmpcme100038-security-by-design">[IDM.PCM.E1.00038] Security by Design</h5>
<blockquote>
<p>The software security MUST be from the beginning a design principle. Means separation of concerns, different administrative roles, especially for private key material and separate access to the data MUST be covered from the first second. It MUST be described in the security concept, what are the different security risks of the product and how they are mitigated (e.g., by Threat Modeling Protocols)  </p>
</blockquote>
<h5 id="idmpcme100039-installation-of-critical-security-updates">[IDM.PCM.E1.00039] Installation of Critical Security Updates</h5>
<blockquote>
<p>Node operators SHALL deploy security critical updates without undue delay.  </p>
</blockquote>
<h5 id="idmpcme100040-avoid-http-request-smuggling">[IDM.PCM.E1.00040] Avoid HTTP Request Smuggling</h5>
<blockquote>
<p>To avoid Request Smuggling attacks, the product MUST implement a standard which handles this kind of attack by design, because the attack vector results in an insufficient implementation of the header handling. The chosen way to handle it MUST be shared with the Principal for further alignment with the other implementers of all other subcomponents within the GXFS project and MUST be described in the security concept.  </p>
</blockquote>
<h5 id="idmpcme100041-pentesting">[IDM.PCM.E1.00041] Pentesting</h5>
<blockquote>
<p>All parts of the product have to be pentested, at least for the following criteria:</p>
</blockquote>
<ol>
<li>
<p>Unauthorized Access to the System MUST be tested</p>
</li>
<li>
<p>Unauthorized Actions MUST be triggered without a user action</p>
</li>
<li>
<p>All Interfaces MUST be tested</p>
</li>
</ol>
<blockquote>
<p>It's RECOMMENDED to test more attack vectors and document it for the purpose to mitigate it in later versions.  </p>
</blockquote>
<h5 id="idmpcme100042-storage-of-secrets">[IDM.PCM.E1.00042] Storage of Secrets</h5>
<blockquote>
<p>The storage of secret information such as private keys MUST take place in state-of-the-art secure environments to protect secret data confidentiality and integrity. Examples of this are Secure Enclaves, TPMs, HSM or Secure Vaults. In case (Personal) Agents are not equipped with a secure storage it MAY also be possible to store the secrets in a third party (e.g., Cloud) provider (e.g., Secure Wallet) that MUST provide overall the same level of security as the aforementioned methods. </p>
</blockquote>
<h5 id="idmpcme100043-secret-distribution-and-usage">[IDM.PCM.E1.00043] Secret Distribution and Usage</h5>
<blockquote>
<p>The product MUST ensure interoperability of cryptographic primitives and components by public standards and MUST use secure state of the art methods to create and import secrets into the secure storage, as well as performing cryptographic operations (e.g., encryption or digital signatures). For Key distribution, state of the art DKMS methods MUST be implemented. </p>
</blockquote>
<h5 id="idmpcme100044-support-for-potential-requirements-for-secret-storages">[IDM.PCM.E1.00044] Support for Potential Requirements for Secret Storages</h5>
<blockquote>
<p>Devices that hold cryptographic information and perform cryptographic functions MUST be compliant with standard PKCS #11 or other comparable cryptography standards. Moreover, the products MUST be potentially eligible for a FIPS-140-2 or ETSI/Common Criteria certification with the minimum-security level necessary to operate securely in the Gaia-X ecosystem. Security Levels in FIPS-140-2 range from 1 to 4. Current HSM Cloud Service offerings (AWS, Azure, GCP) are Level 3 (Source: [FIPS]).</p>
</blockquote>
<h5 id="idmpcme100045-special-availability-and-scalability-requirements-for-secret-storage-components">[IDM.PCM.E1.00045] Special Availability and Scalability Requirements for Secret Storage Components</h5>
<blockquote>
<p>Secret Storage components play a central role in storage, encryption and digital signing in the Gaia-X ecosystem, thus they can become a single point of failure for a Gaia-X participant, for example an organization. Therefore, methods and procedures to ensure the availability and scalability of the Secret Storage functionality MUST be implemented.</p>
</blockquote>
<h3 id="safety-requirements">Safety Requirements</h3>
<h5 id="idmpcme100046-major-releases">[IDM.PCM.E1.00046] Major Releases</h5>
<blockquote>
<p>All used software components MUST use the major releases with Long Term Support. If no LTS is available, all components MUST use the latest major releases with security hardening.  </p>
</blockquote>
<h3 id="security-requirements_1">Security Requirements</h3>
<h5 id="idmpcme100047-cve-patches">[IDM.PCM.E1.00047] CVE Patches</h5>
<blockquote>
<p>All software components MUST have applied CVE patches, which are available for major releases.  </p>
</blockquote>
<h3 id="software-quality-attributes">Software Quality Attributes</h3>
<h5 id="idmpcme100048-software-quality-requirements">[IDM.PCM.E1.00048] Software Quality Requirements</h5>
<blockquote>
<p>All software components MUST be compliant to the requirements within the quality assurance repository [10]. This includes continuing testing, branch models which verify the code quality at check in time and automated behavior testing of all defined quality attributes.  </p>
</blockquote>
<h6 id="10-httpsgitlabcomgaia-xdata-infrastructure-federation-servicesquality-assurance-issues">[10] <a href="https://gitlab.com/gaia-x/data-infrastructure-federation-services/quality-assurance/-/issues"><u>[https://gitlab.com/gaia-x/data-infrastructure-federation-services/quality-assurance/-/issues]</u></a></h6>
<h3 id="business-rules">Business Rules</h3>
<h5 id="idmpcme100049-software-consistency">[IDM.PCM.E1.00049] Software Consistency</h5>
<blockquote>
<p>The used technologies MUST have consistency. Standard technologies e.g., Databases MUST be abstracted over JDBC, authentication over OIDC etc.  </p>
</blockquote>
<h2 id="compliance">Compliance</h2>
<h5 id="idmpcme100050-gdpr-audit-logging">[IDM.PCM.E1.00050] GDPR Audit Logging</h5>
<blockquote>
<p>All GDPR relevant access to personal relevant data MUST be logged for a later audit.  </p>
</blockquote>
<h5 id="idmpcme100051-gdpr-data-processing">[IDM.PCM.E1.00051] GDPR Data Processing</h5>
<blockquote>
<p>If it is necessary to process person-relevant data, it MUST be earmarked to a clearly defined business process, which has to be described in the GDPR design decisions. All relevant personally identifiable data MUST be deleted after the processing, if applicable.
</p>
</blockquote>
<h2 id="design-and-implementation">Design and Implementation</h2>
<blockquote>
<p>Please also refer to [TDR] for further requirements.</p>
</blockquote>
<h3 id="installation">Installation</h3>
<h5 id="idmpcme100052-ios-and-android-installation">[IDM.PCM.E1.00052] iOS and Android Installation</h5>
<blockquote>
<p>The product must be easily installable and comply with the installation requirements depending on the target platforms.  </p>
</blockquote>
<h3 id="distribution">Distribution</h3>
<blockquote>
<p>There are no dedicated distribution requirements for the PCM.</p>
</blockquote>
<h3 id="usability">Usability</h3>
<h5 id="idmpcme100053-gui-usability">[IDM.PCM.E1.00053] GUI usability</h5>
<blockquote>
<p>GUI design MUST comply with common GUI recommendations for the target platforms.  </p>
</blockquote>
<h5 id="idmpcme100054-pcm-accessibility">[IDM.PCM.E1.00054] PCM accessibility</h5>
<blockquote>
<p>The product MUST comply with the accessibility requirements depending on the target platforms. </p>
</blockquote>
<h5 id="idmpcme100055-internationalization-support">[IDM.PCM.E1.00055] Internationalization Support</h5>
<blockquote>
<p>The PCM MUST support internationalization. At least the following languages MUST be supported: English.  </p>
</blockquote>
<h3 id="maintainability">Maintainability</h3>
<h5 id="idmpcme100056-continuous-integration">[IDM.PCM.E1.00056] Continuous Integration</h5>
<blockquote>
<p>All tests MUST be coded in a continuous tool to ensure the software quality in a further development. All the necessary scripts and setups MUST be provided on the public code repository to make it possible for everyone to compile and execute the product.  </p>
</blockquote>
<h3 id="portability">Portability</h3>
<h5 id="idmpcme100057-app-portability">[IDM.PCM.E1.00057] App Portability</h5>
<blockquote>
<p>The product MUST be portable to different devices, e.g., tablets. This includes as well lower end devices (Moto G3, Pixel 4a etc.) to support non-discriminatory all users without consideration of the purchasing power.  </p>
</blockquote>
<h3 id="interoperability">Interoperability</h3>
<h5 id="idmpcme100058-interoperability-of-it-security-features-and-algorithms">[IDM.PCM.E1.00058] Interoperability of IT security features and algorithms</h5>
<blockquote>
<p>The following interoperability requirements of the respective IT security features and algorithms MUST be ensured across the system components:</p>
</blockquote>
<ul>
<li>
<p>Interoperability of crypto algorithms and protocols (including the novel peer-reviewed ones through the established bodies and communities)</p>
</li>
<li>
<p>Interoperability of secure secret transfer protocols (such as the holistic usage of PKCS#11 for HSM communication, etc.)</p>
</li>
<li>
<p>Format interoperability of crypto material (such as the holistic usage of PKCS#12 for relevant cases)  </p>
</li>
</ul>
<h1 id="system-features">System Features</h1>
<h2 id="managing-connections-system-features">Managing Connections - System Features</h2>
<blockquote>
<p>Using this product, the user shall be enabled to manage his Gaia-X connections. Technically, connections are represented by DID-based connections to other Gaia-X participants. Connection data includes the contact DID, DID Document, DIDComm connection status data, and communication history (e.g., VPs exchanged).</p>
<p>Via the PCM, the user must be able to establish DIDComm connections based on invitations, which can be input to the PCM by scanning QR-Codes, Text input (URL), NFC, and by regular DIDComm Messages.</p>
<p>The following functions are required for connection management:</p>
</blockquote>
<table>
<thead>
<tr>
<th>Functional Requirement</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Functions</strong></td>
</tr>
<tr>
<td><u>- Connection creation via invitation </u></td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 4: Functional Requirements Connection Management</p>
</blockquote>
<h2 id="managing-credentials-system-features">Managing Credentials - System Features</h2>
<blockquote>
<p>The product shall enable the user to manage his verifiable credentials (VCs). Other Gaia-X participants can issue VCs to the user in possession of the personal credential manager. The user must be enabled to inspect his VCs and to show/proof VC information via verifiable presentations (VPs) to other Gaia-X participants.</p>
<p>Within the Gaia-X environment, persons in the role of Gaia-X principals need to be able to receive a VC onboarding them as a principal to an organization. Within the PCM, the function "receive a VC" can be used for this purpose.</p>
<p>The following functions are required for management of VCs:</p>
</blockquote>
<table>
<thead>
<tr>
<th>Functional Requirement</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Functions</strong></td>
</tr>
<tr>
<td>- [Receive a Verifiable Credential (VC)]</td>
</tr>
<tr>
<td>- [Answer Request for Identity Information (VP)]</td>
</tr>
<tr>
<td>- [Display history of presenting identity information (VPs) to other participants]</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 5: Functional Requirements Credential Management</p>
</blockquote>
<h2 id="wallet-backup-system-features">Wallet Backup - System Features</h2>
<blockquote>
<p>The product must provide the functionality to create backups of the information stored within the PCM. Backups must be stored in a secure way, so that only the PCM user, who created the backup, can restore the backup. Backups must contain the full status of the PCM.</p>
<p>The following functions are required for backup:</p>
</blockquote>
<table>
<thead>
<tr>
<th>Functional Requirement</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Functions</strong></td>
</tr>
<tr>
<td></td>
</tr>
<tr>
<td>- <u> [Restore Backup] </u></td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 6: Functional Requirements Wallet Backup</p>
</blockquote>
<h2 id="credential-wallet-importingexporting-system-features">Credential Wallet Importing/Exporting - System Features</h2>
<blockquote>
<p>To ensure interoperability between providers, applications and form factors, the PCM must implement a procedure to export and import
personal wallet data and secret information.</p>
<p>The following functions are required for this feature:</p>
</blockquote>
<table>
<thead>
<tr>
<th>Functional Requirement</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Functions</strong></td>
</tr>
<tr>
<td>- <u> [Sync Wallets]</u></td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 7: Functional Requirements Credential Wallet Importing/Exporting</p>
</blockquote>
<h2 id="didcomm-login-support-system-features">DIDComm Login support - System Features</h2>
<blockquote>
<p>The product must be able to scan DIDComm messages via NFC, to support DIDComm login.</p>
</blockquote>
<table>
<thead>
<tr>
<th>Functional Requirement</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Functions</strong></td>
</tr>
<tr>
<td>- <u> [DIDComm Login Support] </u></td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 8: Functional Requirements DIDComm Login support</p>
</blockquote>
<h2 id="nfc-scanning-did-input-system-features">NFC Scanning (DID Input) - System Features</h2>
<blockquote>
<p>The product must be able to scan DIDComm messages via NFC, to support DIDComm login.</p>
</blockquote>
<table>
<thead>
<tr>
<th>Functional Requirement</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Functions</strong></td>
</tr>
<tr>
<td>- <u>[Scan NFC] </u></td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 9: Functional Requirements NFC Scanning (DID Input)</p>
</blockquote>
<h2 id="siop-login-system-features">SIOP Login - System Features</h2>
<blockquote>
<p>The product must provide support for applications to login into services via the SIOP protocol. The following functions are required for this:</p>
</blockquote>
<table>
<thead>
<tr>
<th>Functional Requirement</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Functions</strong></td>
</tr>
<tr>
<td>- <u>[SIOP Login Support] </u></td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 10: Functional Requirements SIOP Login</p>
</blockquote>
<h2 id="app-settings-configuration-personalization-system-features">App Settings Configuration (personalization) - System Features</h2>
<blockquote>
<p>The product must provide means to the PCM user to configure and save PCM application preferences. The following functions are required for this:</p>
</blockquote>
<table>
<thead>
<tr>
<th>Functional Requirement</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Functions</strong></td>
</tr>
<tr>
<td>- <u>[Configure Cloud wallet linking] </u></td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 11: Functional Requirements App Settings Configuration (personalization)</p>
</blockquote>
<h2 id="ledger-selection-system-features">Ledger Selection - System Features</h2>
<h5 id="idmpcme100059-ledger-support-did-and-ledger-agnostic-behavior">[IDM.PCM.E1.00059] Ledger Support (DID) and Ledger-agnostic behavior</h5>
<blockquote>
<p>The product MUST support multiple Ledgers according to the Architecture Overview [IDM.AO] , e.g., it MUST NOT be bound to a dedicated Ledger by design and the PCM user should not be able to select ledgers - It\'s pre-configured .  </p>
</blockquote>
<pre><code>| Functional Requirement |
</code></pre>
<p>| ---------------------- |
| <strong>Functions</strong>         |
| - <u>[Select Ledger] </u> |</p>
<blockquote>
<p>Table 12: Functional Requirements Ledger Selection</p>
</blockquote>
<h2 id="smartphone-application">Smartphone Application</h2>
<h5 id="smartphone-application_1">Smartphone Application</h5>
<blockquote>
<p>The product MUST implement the form factor "Smartphone Application", so that the PCM can be used as a full-featured app that implements the GUI functionalities, the connectivity functionalities and credential and personal wallet management locally on the smartphone. The backup/restore mechanisms and the configuration management are handled as well in the mobile Smartphone app. This alternative can benefit from all physical input and output interfaces present in a Smartphone, such as cameras for scanning QR-Codes for connection invitations or the NFC communication. Because Smartphones do not usually have a fixed communication endpoint an SSI-Mediator needs to remain in the Cloud for PCM Notifications.</p>
<p>The smartphone application MUST include the following system features:</p>
</blockquote>
<ul>
<li>
<p>Managing Connections</p>
</li>
<li>
<p>Managing Credentials</p>
</li>
<li>
<p>Wallet Backup</p>
</li>
<li>
<p>End User Authentication</p>
</li>
<li>
<p>QR-Code scanning (DID Input)</p>
</li>
<li>
<p>Notification Support</p>
</li>
<li>
<p>App Settings Configuration</p>
</li>
<li>
<p>Ledger Selection</p>
</li>
</ul>
<blockquote>
<p>The smartphone application additionally include the following system features:</p>
</blockquote>
<ul>
<li>
<p>Credential Wallet Importing/Exporting/Syncing</p>
</li>
<li>
<p>NFC tag generation and scanning</p>
</li>
<li>
<p>SIOP Login</p>
</li>
</ul>
<h1 id="verification">Verification</h1>
<h2 id="core-verification-requirements">Core Verification Requirements</h2>
<h5 id="idmpcme100060-behavior-driven-design">[IDM.PCM.E1.00060] Behavior Driven Design</h5>
<blockquote>
<p>Verification of fulfillment of the requirements and characteristics MUST be done using automated tests which are part of the deliverables. They SHOULD be done by patterns of the Behavior Driven Development [BDD] using the "Gherkin Syntax".  </p>
</blockquote>
<h2 id="functionality-acceptance-criteria">Functionality Acceptance Criteria</h2>
<h3 id="connections">Connections</h3>
<h5 id="idmpcme100063-connection-invitation">[IDM.PCM.E1.00063] Connection invitation</h5>
<blockquote>
<p>When users are authenticated, then they can receive notification for "Connection" via QR-Code, Text input (URL), NFC. The information is shown to the users via the GUI and requests can be validated. The users can accept or to reject the request. When the request is accepted, then the PCM performs the DIDComm protocol required to establish the connection. The connection must be established and stored in the PCM storage, so that it can be used later.  </p>
</blockquote>
<h3 id="managing-credentials-verification">Managing credentials - Verification</h3>
<h5 id="idmpcme100064-receive-a-verifiable-credential-vc">[IDM.PCM.E1.00064] Receive a Verifiable Credential (VC)</h5>
<blockquote>
<p>When a user is authenticated and within an established connection, the user must get notification for VC issuing requests. The user must get the possibility to accept or to reject the request. The request is validated, and the information is shown to the user via the GUI. The issued credential MUST be stored in connected OCM(s) of the cPCM and synced to PCM in the case of a W3C credential. In the case of an Indy credential, the App MUST show the credential by using the remote functionality but MUST NOT sync the indy credential physically. In both cases, two credentials are visible in the PCM App, the indy one is highlighted as "cloud credential", the other one as "Local Credential". When the PCM App receives a Indy/W3C credential directly from an OCM, the credential MUST be also marked as "Local Credential". Is any "cloud credential" removed from an connected OCM within the cPCM, the App will sync those changes and push the credential to history overview.  </p>
</blockquote>
<h5 id="idmpcme100065-answer-request-for-verifiable-presentation-vp">[IDM.PCM.E1.00065] Answer Request for Verifiable Presentation (VP)</h5>
<blockquote>
<p>When users are authenticated and Connection established, then:</p>
</blockquote>
<ul>
<li>
<p>If the user has given his consent, a VP has been proved to the verifier.</p>
</li>
<li>
<p>If the presentation has not been completed successfully, problems have been reported to the users via GUI.</p>
</li>
</ul>
<blockquote>
<p>The App MUST demonstrate that (synced) W3C or Indy Credentials can be presented offline without any connection to the cPCM. In the online case, the App MUST demonstrate that a credential can be presented via the remote control of the cPCM.  </p>
</blockquote>
<h5 id="idmpcme100066-display-history-of-presenting-verifiable-presentations-vps">[IDM.PCM.E1.00066] Display history of presenting verifiable presentations (VPs)</h5>
<blockquote>
<p>When users are authenticated, then they can view detailed information about the history of showing/proofing identity information to other participants. History information must list information about the transaction date and time, and to whom has been presented.  </p>
</blockquote>
<h5 id="idmpcme100067-restore-backup">[IDM.PCM.E1.00067] Restore Backup</h5>
<blockquote>
<p>When users are authenticated, they must have a function to restore a backup containing all information stored in the PCM and Cloud wallet (cPCM). When users select the backup file, the restore must be performed only after confirming the security authentication. When successful restoration is completed, users should be informed about the status and they must see all their data(such as VC, Connections, etc.).  </p>
</blockquote>
<h5 id="idmpcme100068-card-view">[IDM.PCM.E1.00068] Card View</h5>
<blockquote>
<p>The PCM MUST present all credentials as cards (like credit cards), with a logo if the credential is in the cloud available or local. The view MUST support easy selection and combination of credentials for the different remote and local use cases.  </p>
</blockquote>
<h3 id="credential-wallet-synchronization">Credential Wallet synchronization</h3>
<h5 id="idmpcme100069-sync-wallets">[IDM.PCM.E1.00069] Sync Wallets</h5>
<blockquote>
<p>When users are authenticated, then they must be able to configure synchronization with Cloud Wallet(cPCM). After successfully establishing a secure connection, then bi-directional synchronization MUST be triggered by using DIDComm v2 messages. A DIDComm v2 protocol is provided an documented for each use case of the cPCM (e.g., list VCs)  </p>
</blockquote>
<h3 id="nfc">NFC</h3>
<h5 id="idmpcme100070-scan-nfc">[IDM.PCM.E1.00070] Scan NFC</h5>
<blockquote>
<p>A user MUST be able to scan an active NFC tag which can contain W3C VC/VP or Connection Invitations. The App MUST successfully process that.  </p>
</blockquote>
<h5 id="idmpcme100071-write-nfc">[IDM.PCM.E1.00071] Write NFC</h5>
<blockquote>
<p>A user MUST be able to write an NFC tag which can contain W3C VC/VP or Connection Invitations. Another PCM on a mobile device MUST accept that presentation.  </p>
</blockquote>
<h3 id="siop-login-support">SIOP Login Support</h3>
<h5 id="idmpcme100072-siop-login-support">[IDM.PCM.E1.00072] SIOP Login Support</h5>
<blockquote>
<p>The cPCM MUST implement a function to process SIOP requests [DID SIOP] in the role of the Self- Issued OpenID Provider (SIOP). Applications (RPs (Relying Parties) in SIOP terminology) can send SIOP requests to the PCM. The PCM will process such requests and reply with a SIOP response.  </p>
</blockquote>
<h3 id="app-settings-configuration-personalization-verification">App Settings Configuration (personalization) - Verification</h3>
<h5 id="idmpcme100073-configure-cloud-wallet-linking">[IDM.PCM.E1.00073] Configure cloud wallet linking</h5>
<blockquote>
<p>When users are authenticated, the PCM MUST enable the users to configure secure connection(management link) to Cloud wallet. </p>
</blockquote>
<h3 id="ledger-selection-verification">Ledger Selection - Verification</h3>
<h5 id="idmpcme100074-select-ledger">[IDM.PCM.E1.00074] Select Ledger</h5>
<blockquote>
<p>The PCM MUST not be enabled to select compatible Ledgers from the PCM GUI. The selection is pre-configured from a list of supported ledgers during the build process.  </p>
</blockquote>
<h3 id="mediator-selection-verification">Mediator Selection - Verification</h3>
<h5 id="idmpcme100075-select-mediator">[IDM.PCM.E1.00075] Select Mediator</h5>
<blockquote>
<p>The PCM MUST be able to work with different Mediators by using the DID Document, without recompiling the app.  </p>
</blockquote>
<h3 id="cloud-wallet-management-verification">Cloud Wallet Management - Verification</h3>
<h5 id="idmpcme100076-remote-controller-of-the-cloud-pcm-cpcm">[IDM.PCM.E1.00076] Remote controller of the Cloud PCM (cPCM)</h5>
<blockquote>
<p>The PCM user MUST be able to control the basic functions of the Cloud PCM(cPCM) such as Consent management, Connection Acceptance, Presentation Allowance, Issuing and Credential management. When users are authenticated and secure management connection is established with cPCM, then the users must be able to consent and access to existing documents.  </p>
</blockquote>
<h5 id="idmpcme100077-plugin-management">[IDM.PCM.E1.00077] Plugin Management</h5>
<blockquote>
<p>The plugin management of the cPCM MUST be supported in the App. It MUST be possible to use the plugins, configured and enable/disable them remotely. The remote protocol MUST be used to request from plugins a token, present that token to verifiers or holders. All other standard functionality like issuing of credentials, consent etc. which the plugin framework of the cPCM offers, must be supported as well. </p>
</blockquote>
<h2 id="appendix-a-glossary">Appendix A: Glossary</h2>
<blockquote>
<p>For the glossary refer to IDM.AO Glossary/Terminology [IDM.AO]</p>
</blockquote>
<h2 id="appendix-b-consent-management">Appendix B: Consent Management</h2>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /> </p>
<p>The flows are just for example. Flow optimizations can be proposed. </p>
</blockquote>
<hr />
<p><strong>Flow 1: External Actor requests Access to Protected API</strong></p>
<p><img alt="" src="../media/image5.jpeg" /></p>
<blockquote>
<p><strong>Flow 2: External Actor gives Access to protected Resources</strong></p>
</blockquote>
<p><img alt="" src="../media/image6.jpeg" /></p>
<h2 id="appendix-c-personal-credential-manager-layering-overview">Appendix C: Personal Credential Manager Layering overview</h2>
<p><img alt="" src="../media/image7.png" /></p>
              
            </div>
          </div><footer>
    <div class="rst-footer-buttons" role="navigation" aria-label="Footer Navigation">
        <a href="../../pcmcloud/pcmcloud/" class="btn btn-neutral float-left" title="Cloud Personal Credential Manager"><span class="icon icon-circle-arrow-left"></span> Previous</a>
        <a href="../../tsae1/tsae1/" class="btn btn-neutral float-right" title="Trust Services API Extension">Next <span class="icon icon-circle-arrow-right"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
  </div>

  Built with <a href="https://www.mkdocs.org/">MkDocs</a> using a <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
          
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" aria-label="Versions">
  <span class="rst-current-version" data-toggle="rst-current-version">
    
    
      <span><a href="../../pcmcloud/pcmcloud/" style="color: #fcfcfc">&laquo; Previous</a></span>
    
    
      <span><a href="../../tsae1/tsae1/" style="color: #fcfcfc">Next &raquo;</a></span>
    
  </span>
</div>
    <script src="../../js/jquery-3.6.0.min.js"></script>
    <script>var base_url = "../..";</script>
    <script src="../../js/theme_extra.js"></script>
    <script src="../../js/theme.js"></script>
      <script src="../../search/main.js"></script>
    <script>
        jQuery(function () {
            SphinxRtdTheme.Navigation.enable(true);
        });
    </script>

</body>
</html>
